<%--
  To be used in conjunction with Form.jsp or MailForm.jsp, where the Persistence property is set to a string like this:
  
  {"jsp":"/r/persist.jsp", "entity":"/system/modules/com.codedroids.oc.contacts/setup/Contact.rec.xml"}

  The example uses a Contact entity assuming that the form used is one that makes sense in that context.
  The code is equivalent to OCFormUtils.saveFormToRecord() method, which the above scripts invokes if the
  Entity-property is set to an appropriate entity file. So generally no need to use this JSP "detour" if that is 
  all you want, but you can of course add more complex functionality here, such as saving form content to more
  than one entity or may be some extra processing.
  
--%><%@ 
page session="false" %><%@ 
page import="net.sf.json.JSONObject, 
             org.opencms.jsp.*, com.codedroids.forms.*, com.codedroids.oc.forms.*,
             com.codedroids.records.*, com.codedroids.oc.records.*"
%><%
  CmsJspActionElement cms = new CmsJspActionElement(pageContext, request, response);

  Form form = (Form)pageContext.getAttribute(PersistViaJsp.formAttributeName, PageContext.REQUEST_SCOPE);
  JSONObject conf = (JSONObject)pageContext.getAttribute(PersistViaJsp.configAttributeName, PageContext.REQUEST_SCOPE);
  
  if(form != null && conf != null) {
    String entityFile = conf.getString("entity");
	RecordFactory factory = OCRecordFactory.registerFactory(cms.getCmsObject(), entityFile);
    I_Record cd = factory.getNewInstance();
    form.pushToRecord(cd);
    // for convenience these are set if they exists
    if(cd.hasField("creator"))
      cd.takeValueForKey("creator", cms.user("name"));
    if(cd.hasField("creationDate"))
      cd.takeValueForKey("creationDate", new java.sql.Timestamp(System.currentTimeMillis()));
    if(cd.hasField("lastIp") && pageContext != null)
      cd.takeValueForKey("lastIp", pageContext.getRequest().getRemoteHost());
    factory.saveRecord(cd);
    cd = null;
  }
%>